﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using JsonConvertSample.Models;
using System.Diagnostics;
using System.Web.Script.Serialization;
using JsonConvertSample.Common;

//=====================================================
//Copyright (C)   www.cnblogs.com/luge
//All rights reserved
//文件名:           HomeController
//创建时间:         2015-06-21
//当前登录用户名:   卤鸽
//描述：             
//======================================================
      
namespace JsonConvertSample.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/


        private IList<User> InitUserList(int capacity)
        {
            var list = new List<User>() { Capacity = capacity };

            for (int i = 0; i < capacity; i++)
            {
                var user = new User()
                {
                    UserID = i,
                    UserName = "卤鸽" + i.ToString(),
                    BirthDate = DateTime.Now,
                    Saraly = 1234.5m + i,
                    Location = new Address() { City = "福州市" + i.ToString(), Province = "福建省" + i.ToString() },
                    Schools = new List<School>() { new School() { SchoolName = "小学" + i.ToString(), SchoolDesc = "三条杠" }, new School() { SchoolName = "中学" + i.ToString(), SchoolDesc = "好好学生" } }
                };
                list.Add(user);
            }
            return list;
        }

        public ActionResult Index(int? capacity)
        {
            capacity = capacity ?? 1;

            var list = InitUserList(capacity.Value);

            var jsonCompare = new JsonCompare() { Capacity = capacity.Value };
            Stopwatch sw = new Stopwatch();
            sw.Start();

            jsonCompare.DcsString = JsonFormat.SerializeByContract<IList<User>>(list);

            sw.Stop();
            jsonCompare.DataContractSerializeTime = sw.ElapsedTicks;

            sw.Reset();
            sw.Start();

            jsonCompare.jsString = JsonFormat.SerializeByJavaScript<IList<User>>(list);

            sw.Stop();
            jsonCompare.JavascriptSerializeTime = sw.ElapsedTicks;

            sw.Reset();
            sw.Start();

            jsonCompare.jnString = JsonFormat.SerializeByJsonNet<IList<User>>(list);

            sw.Stop();
            jsonCompare.JsonNetTime = sw.ElapsedTicks;
            sw.Reset();

            #region 反序列化


            //sw.Start();

            // JsonFormat.DeserializeByContract<IList<User>>(jsonCompare.DcsString);

            //sw.Stop();
            //jsonCompare.DataContractSerializeTime = sw.ElapsedTicks;

            //sw.Reset();
            //sw.Start();

            // JsonFormat.DeserializeByJavaScript<IList<User>>(jsonCompare.jsString);

            //sw.Stop();
            //jsonCompare.JavascriptSerializeTime = sw.ElapsedTicks;

            //sw.Reset();
            //sw.Start();

            //JsonFormat.DeserializeByJsonNet<IList<User>>(jsonCompare.jnString);
            //sw.Stop();
            //jsonCompare.JsonNetTime = sw.ElapsedTicks;
            #endregion 


            //var tp = JsonFormat.DeserializeByContract<IList<User>>(jsonCompare.jnString,JsonFormat.ISO_TO_DATE_PATTERN);

            return View(jsonCompare);
        }

    }
}
